{$X+}
uses
   CRT,
   GraphDrv,
   PDrawLat, PDrawNum, PDrawSpc, PDrawRus;       { Fonts }

var
   n               :String[12];
   i, x, y, c      :Integer;

   p1, p2          :Pointer;
   s               :Word;

procedure Msg(Proc, Msg      :String);
begin
   if Proc<>'' then ClearDevice(c) else Bar(0, 0, GetMaxX, 7, c);
   SetUserCharSize(1, 1, 1, 1);
   SetTextJustify(CenterText, TopText);
   SetTextAngle(0);
   if Proc<>'' then Proc:='~'+Proc+'.~ ';
   OutColoredTextXY(GetMaxX div 2, 0, Proc+Msg, Yellow, White);
end;

procedure WaitKey;
begin
   Delay(200);
   Msg('', 'Press any key to continue ...');
   ReadKey;
end;

begin
   write('Enter driver name WITHOUT extension (default: VGA) : '); readln(n);
   if n='' then n:='VGA.DRV' else n:=n+'.DRV';
   writeln;

   if LoadDriver(n)<>gdOk then
   begin
      writeln('Error loading driver !'); Halt;
   end;

   writeln(DriverPTR^.Header);
   writeln(DriverPTR^.Copyright);
   writeln;
   writeln('PutPixel   : ', Supported(PutPixel));
   writeln('GetPixel   : ', Supported(GetPixel));
   writeln('Line       : ', Supported(Line));
   writeln('PutImage   : ', Supported(PutImage));
   writeln('TurnBlockX : ', Supported(TurnBlockX));
   writeln('ChangeColor: ', Supported(ChangeColor));
   writeln;
   writeln('Normal Put : ', PutModeSupported(NormalPut));
   writeln('Xor    Put : ', PutModeSupported(XorPut));
   writeln('And    Put : ', PutModeSupported(AndPut));
   writeln('Or     Put : ', PutModeSupported(OrPut));
   writeln;
   writeln('Press any key to continue ...');
   ReadKey;

   SetGraphMode;

   if DriverPTR^.MaxColor>3 then c:=Blue else c:=Black;

   Msg('PutPixel', '(20000 times)');
   for i:=1 to 20000 do PutPixel(Random(GetMaxX+1), Random(GetMaxY+1-8)+8,
      Random(DriverPTR^.MaxColor+1));
   WaitKey;

   Msg('Line', '(1000 times, NormalPut)');
   for i:=1 to 1000 do Line(Random(GetMaxX+1), Random(GetMaxY+1-8)+8,
      Random(GetMaxX+1), Random(GetMaxY+1-8)+8, Random(DriverPTR^.MaxColor+1));
   WaitKey;

   if PutModeSupported(XorPut) then
   begin
      Msg('Line', '(1000 times, XorPut)');
      DriverPTR^.PutMode:=XorPut;
      for i:=1 to 1000 do Line(Random(GetMaxX+1), Random(GetMaxY+1-8)+8,
         Random(GetMaxX+1), Random(GetMaxY+1-8)+8, Random(DriverPTR^.MaxColor+1));
      DriverPTR^.PutMode:=NormalPut;
      WaitKey;
   end;

   Msg('Rectangle', '');
   for i:=0 to GetMaxX div 2 do Rectangle(i, i+8, GetMaxX-i, GetMaxY-i+8,
      i mod DriverPTR^.MaxColor);
   WaitKey;

   Msg('Bar', '(NormalPut)');
   for i:=0 to DriverPTR^.MaxColor do
   begin
      x:=LongInt(i)*GetMaxX div (DriverPTR^.MaxColor+1);
      y:=LongInt(i)*GetMaxY div (DriverPTR^.MaxColor+1);
      Bar(x, y, x+20, y+20, i);
   end;
   WaitKey;

   Msg('Bar', '(XorPut)');
   DriverPTR^.PutMode:=XorPut;
   for i:=0 to DriverPTR^.MaxColor do
   begin
      x:=LongInt(i)*GetMaxX div (DriverPTR^.MaxColor+1);
      y:=LongInt(i)*GetMaxY div (DriverPTR^.MaxColor+1);
      Bar(x, y, x+20, y+20, i);
   end;
   DriverPTR^.PutMode:=NormalPut;
   WaitKey;

   Msg('Circle', '');
   Circle(GetMaxX div 2, GetMaxY div 2, GetMaxY div 3, Red);
   WaitKey;

   Msg('Ellipse', '');
   Ellipse(GetMaxX div 2, GetMaxY div 2, 0, 270,
      GetMaxX div 4, GetMaxY div 6, Red);
   WaitKey;

   Msg('CircleRadius', '');
   for i:=0 to 360 do
   begin
      CircleRadius(GetMaxX div 2, GetMaxY div 2, i-1, GetMaxY div 3, c);
      CircleRadius(GetMaxX div 2, GetMaxY div 2, i, GetMaxY div 3, White);
      Delay(5);
   end;
   WaitKey;

   Msg('Setting text parameters', '');
   SetUserCharSize(3, 1, 2, 1);
   SetTextAngle(30);
   SetTextJustify(CenterText, CenterText);

   for i:=0 to 360 div 15 do
   begin
      OutTextXY(GetMaxX div 2, GetMaxY div 2, 'Text. .', c);
      SetTextAngle(i*15);
      OutTextXY(GetMaxX div 2, GetMaxY div 2, 'Text. .', White);
      Delay(50);
   end;
   WaitKey;

   if Supported(GetPixel) then
   begin
      Msg('FloodFill', '');
      Circle(GetMaxX div 2, GetMaxY div 2, GetMaxY div 3, Yellow);
      Line(GetMaxX div 2, 0, GetMaxX div 2, GetMaxY, White);
      FloodFill(GetMaxX div 2-1, GetMaxY div 2-1, Green, c);

      if Supported(GetImage) then
      begin
         x:=GetMaxX div 2-80; y:=GetMaxY div 2-80;
         s:=ImageSize(x, y, x+60, y+60);
         if s*2<=MaxAvail then
         begin
            GetMem(p1, s); GetMem(p2, s);
            GetImage(x, y, x+60, y+60, p1);
         end
         else p1:=nil;
      end
      else p1:=nil;

      WaitKey;

      if p1<>nil then
      begin
         Msg('GetImage/PutImage & TurnBlock', '');
         for i:=0 to 20 do PutImage(x+i*3, y+i*3, p1);
         WaitKey;

         Msg('TurnBlockX/Y', '');
         PutImage(10, 20, p1);
         TurnBlockX(p1, p2);
         PutImage(90, 20, p2);
         TurnBlockY(p1, p2);
         PutImage(170, 20, p2);
         WaitKey;
      end;
   end;

   if Supported(ChangeColor) then
   begin
      Msg('ChangeColor', 'Press any key to stop.');
      for i:=0 to DriverPTR^.MaxColor do
      Line(Random(GetMaxX+1), Random(GetMaxY+1-8)+8,
         Random(GetMaxX+1), Random(GetMaxY+1-8)+8, i);
      while not KeyPressed do ChangeColor(Random(GetMaxX+1), Random(GetMaxY+1-8)+8,
         Random(GetMaxX+1), Random(GetMaxY+1-8)+8,
         Random(DriverPTR^.MaxColor+1), Random(DriverPTR^.MaxColor+1));
      WaitKey;
   end;

   CloseGraph;
end.
